﻿Public Class CustomImageColumnHeader
    Implements ITemplate


    Private msImageUrl As String = "~/Images/Empty.jpg"
    Private msAlternateText As String = "No Value"
    Private moContainer As Web.UI.Control
    Private moImageAlignment As System.Web.UI.WebControls.ImageAlign = ImageAlign.Middle
    Private msToolTip As String = String.Empty


    Public Property AlternateText() As String
        Get
            Return msAlternateText
        End Get
        Set(value As String)
            msAlternateText = value
        End Set
    End Property


    Public Property ImageAlignment() As System.Web.UI.WebControls.ImageAlign
        Get
            Return moImageAlignment
        End Get
        Set(value As System.Web.UI.WebControls.ImageAlign)
            moImageAlignment = value
        End Set
    End Property


    Public Property ImageUrl() As String
        Get
            Return msImageUrl
        End Get
        Set(value As String)
            msImageUrl = value
        End Set
    End Property


    Public Property ToolTip() As String
        Get
            Return msToolTip
        End Get
        Set(value As String)
            msToolTip = value
        End Set
    End Property


    Public Sub InstantiateIn(container As System.Web.UI.Control) Implements System.Web.UI.ITemplate.InstantiateIn
        Try
            Dim imageControl As WebControls.Image = New WebControls.Image()

            imageControl.ImageUrl = msImageUrl
            imageControl.AlternateText = msAlternateText
            imageControl.ImageAlign = moImageAlignment
            'CType(moContainer.Controls(0), WebControls.Image).Height =
            'CType(moContainer.Controls(0), WebControls.Image).Width =
            'CType(moContainer.Controls(0), WebControls.Image).Style = 
            imageControl.ToolTip = IIf(msToolTip.Length = 0, msAlternateText, msToolTip)

            container.Controls.Add(imageControl)
            moContainer = container

        Catch ex As Exception
            Throw ex
        End Try
    End Sub


    Public Sub New(psImageUrl As String, psAlternateText As String)
        msAlternateText = psAlternateText
        msImageUrl = psImageUrl
        msToolTip = msAlternateText
    End Sub


    Public Sub New(psImageUrl As String, psAlternateText As String, poImageAlignment As System.Web.UI.WebControls.ImageAlign)
        msAlternateText = psAlternateText
        msImageUrl = psImageUrl
        moImageAlignment = poImageAlignment
        msToolTip = msAlternateText
    End Sub


    Public Sub New(psImageUrl As String, psAlternateText As String, poImageAlignment As System.Web.UI.WebControls.ImageAlign, psToolTip As String)
        msAlternateText = psAlternateText
        msImageUrl = psImageUrl
        moImageAlignment = poImageAlignment
        msToolTip = psToolTip
    End Sub


    ''' <summary>
    ''' Assumes all values have been previously set
    ''' </summary>
    ''' <remarks>
    ''' Assumes all values have been previously set
    ''' </remarks>
    Public Sub SetValues()
        Try
            If moContainer IsNot Nothing AndAlso moContainer.Controls.Count = 1 Then
                CType(moContainer.Controls(0), WebControls.Image).ImageUrl = msImageUrl
                CType(moContainer.Controls(0), WebControls.Image).AlternateText = msAlternateText
                CType(moContainer.Controls(0), WebControls.Image).ImageAlign = moImageAlignment
                CType(moContainer.Controls(0), WebControls.Image).ToolTip = IIf(msToolTip.Length = 0, msAlternateText, msToolTip)
            End If

        Catch ex As Exception
            Throw ex
        End Try
    End Sub

    Public Sub SetValues(psImageUrl As String, psAlternateText As String)
        Try
            msAlternateText = psAlternateText
            msImageUrl = psImageUrl

            If moContainer IsNot Nothing AndAlso moContainer.Controls.Count = 1 Then
                CType(moContainer.Controls(0), WebControls.Image).ImageUrl = msImageUrl
                CType(moContainer.Controls(0), WebControls.Image).AlternateText = msAlternateText
                CType(moContainer.Controls(0), WebControls.Image).ImageAlign = moImageAlignment
                CType(moContainer.Controls(0), WebControls.Image).ToolTip = IIf(msToolTip.Length = 0, msAlternateText, msToolTip)
            End If

        Catch ex As Exception
            Throw ex
        End Try
    End Sub

    Public Sub SetValues(psImageUrl As String, psAlternateText As String, poImageAlignment As System.Web.UI.WebControls.ImageAlign)
        Try
            msAlternateText = psAlternateText
            msImageUrl = psImageUrl
            moImageAlignment = poImageAlignment

            If moContainer IsNot Nothing AndAlso moContainer.Controls.Count = 1 Then
                CType(moContainer.Controls(0), WebControls.Image).ImageUrl = msImageUrl
                CType(moContainer.Controls(0), WebControls.Image).AlternateText = msAlternateText
                CType(moContainer.Controls(0), WebControls.Image).ImageAlign = moImageAlignment
                CType(moContainer.Controls(0), WebControls.Image).ToolTip = IIf(msToolTip.Length = 0, msAlternateText, msToolTip)
            End If

        Catch ex As Exception
            Throw ex
        End Try
    End Sub


    Public Sub SetValues(psImageUrl As String, psAlternateText As String, poImageAlignment As System.Web.UI.WebControls.ImageAlign, psToolTip As String)
        Try
            msAlternateText = psAlternateText
            msImageUrl = psImageUrl
            moImageAlignment = poImageAlignment
            msToolTip = psToolTip

            If moContainer IsNot Nothing AndAlso moContainer.Controls.Count = 1 Then
                CType(moContainer.Controls(0), WebControls.Image).ImageUrl = msImageUrl
                CType(moContainer.Controls(0), WebControls.Image).AlternateText = msAlternateText
                CType(moContainer.Controls(0), WebControls.Image).ImageAlign = moImageAlignment
                CType(moContainer.Controls(0), WebControls.Image).ToolTip = msToolTip
            End If

        Catch ex As Exception
            Throw ex
        End Try
    End Sub
End Class
